import typing
from bs4 import BeautifulSoup
import requests
import string

INDEX = [""] + list(map(lambda x: "/" + x, list(string.ascii_lowercase)[1:]))

def get_ingredientsFileContent() -> typing.Tuple[list[str], bool]:
    ingredients_list = []
    empty_file = True
    try:
        with open("ingredients1.tsv", "r") as f:
            tmp = f.read()
            if len(tmp) != 0:
                empty_file = False
                ingredients_list = tmp.split("\t")
    except FileNotFoundError:
        with open("ingredients1.tsv", "w") as f:
            f.write("")
    return ingredients_list, empty_file

def update_file(ingredients_add : list[str], empty_file : bool) -> None:
    if len(ingredients_add) != 0:
        with open("ingredients1.tsv", "a") as f:
            if empty_file:
                f.write("\t".join(ingredients_add))
            else:
                f.write("\t" + "\t".join(ingredients_add))
    return

def get_ingredients(soup : BeautifulSoup, ingredients_list) -> list[str] :
    ingredients_add = []
    ingredients = soup.find_all("div", class_="recipe-results")
    if ingredients is not None:
        ingredients = ingredients[0].find_all("div", class_="index-item-card")
        for ingredient in ingredients:
            if ingredient is not None:
                name_ing = ingredient.find("div", class_="index-item-card-name")
                if name_ing is not None:
                    to_add = name_ing.text.strip()
                    if to_add not in ingredients_list:
                        ingredients_add += [to_add]
                # try:
                #     to_add = ingredient.find("a")["href"][27:]
                #     if to_add not in ingredients_list:
                #         ingredients_add += [to_add]
                # except KeyError:
                #     None
    return ingredients_add

def get_pagesNb(soup : BeautifulSoup) -> int :
    page_toto = 0
    pages = soup.find("div",class_="showMorePages")
    if pages is not None:
        li_tag = pages.findAll("li")
        page_toto = li_tag[len(li_tag)-1].text
    else:
        pages = soup.find("nav", class_="af-pagination")
        if pages is not None:
            li_tag = pages.findAll("li")
            page_toto = li_tag[len(li_tag)-1].text
    return page_toto


for letter in INDEX:
    url = "https://www.marmiton.org/recettes/index/ingredient"+letter

    res = requests.get(url)
    if res.status_code == 200:
        print("ok, get url: " + url)

        soup = BeautifulSoup(res.text, "html5lib")

        page_toto = get_pagesNb(soup)

        if page_toto != 0:
            for i in range(int(page_toto)):
                if i != 0:
                    new_url = url + "/" + str(i+1)
                else:
                    new_url = url
                
                new_res = requests.get(new_url)

                if new_res.status_code == 200:
                    print("ok, get url: " + new_url)

                    new_soup = BeautifulSoup(new_res.text, "html5lib")

                    ingredients_list, empty_file = get_ingredientsFileContent()

                    ingredients_add = get_ingredients(new_soup, ingredients_list)

                    update_file(ingredients_add,empty_file)
        else:
            ingredients_list, empty_file = get_ingredientsFileContent()

            ingredients_add = get_ingredients(soup, ingredients_list)

            update_file(ingredients_add,empty_file)
    else:
        print(f"Error: {res.status_code} at url: " + url)
